//lab18 Elodie Rafalimanana 17/04/09
import java.awt.event.*;
PImage img, previousFrame, modifiedImg;
Boolean loaded = false;
Boolean saved = false;
Boolean about = false;

Menu mainMenu;
ArrayList menuButtons = null;
Transform transform;
Filter filter;

int buttonSize = 120;
int menuHeight = (int)(buttonSize/3);
int menuWidth = (int)(buttonSize);
int menuPressed = -1, submenuPressed = -1;//Otherwise set to 0 automatically if not set ..bug

void setup () {
  smooth();
  mainMenu = new Menu(buttonSize);
  transform = new Transform();
  filter = new Filter();
  size(6*buttonSize,6*buttonSize);
  frame.setResizable(true); //Allows to resize the display window for a better view of the image
  background(0,57,66);
  
  mainMenu.writeCredits(); 

}

void draw(){
  
  if(loaded){  
    menuButtons = new ArrayList(Arrays.asList("Open image","Save image", "Original", "Filters", "Transform", "About"));//when an image is loaded the full menu appears
  }
  else{
    menuButtons = new ArrayList(Arrays.asList("Open image"));//at start only the open button is present
  }

 menuWidth = menuButtons.size()*buttonSize;

//Switch for menu and submenu
switch(menuPressed){//menuPressed comes from the mousePressed function normally img is already loaded

case 0://open button, displays the loaded image or go back button
 if(loaded){//means img!= null
   previousFrame = previousFrame != null ? previousFrame : img; //if the image has just been loaded previous frame should be the loaded image, otherwise previous frame is the modified image
    if(about == false){//case button is not go back button, in normal mode the loop must be active
      loop();
    }
    image(previousFrame, 0, 0,width,height);//draws the image
 }
break;
 
case 1://save
   previousFrame = previousFrame != null ? previousFrame : img;//previous frame exists if you have clicked on save button or about button, if you've just loaded the image previous frame = img
   image(previousFrame, 0, 0,width,height);
   if(saved == false){
     String savePath = selectOutput("Save image as");
     if(savePath != null){
       save(savePath);
       saved = true;
     }
     else{//you cancelled the saving
       saved = false;
       menuPressed = -1;
     }   
   }
break;

case 2://original button, displays the original image
  image(img, 0, 0,width,height);
  previousFrame=img;
break;
 
case 3://Filters
menuHeight = buttonSize/3;//reset the menu height when the submenus are not displayed, so submenus don't trigger if not visible
  switch(submenuPressed){
     ////////////////// //Filters Menu//////////////////////
    case 0 :
      previousFrame =  previousFrame != null ? previousFrame : img;
      image(previousFrame,0,0,width,height);//allow to wipe the other submenu if it was open
      String[] filterButtons = {"Exit menu", "B&W", "Blur", "Threshold", "Sepia", "Invert", "Posterize", "Warhol1", "Warhol2"};
      mainMenu.createSubmenu(filterButtons, menuPressed);
      menuHeight=(filterButtons.length+1)*buttonSize/3;//+1 = the parent menu button Filters     
    break;
    ////////////////// //Exit Menu//////////////////////
    case 1 :
      previousFrame =  previousFrame != null ? previousFrame : img;
      image(previousFrame,0,0,width,height);
    break;
    ////////////////// //B&W Filter//////////////////////
    case 2:
       filter.bw(img);
       previousFrame = filter.modifiedImg;
    break;
    ////////////////// //Blur Filter//////////////////////
    case 3:
       filter.blur(img);
       previousFrame = filter.modifiedImg;   
    break;
    ////////////////// //Threshold Filter//////////////////////
    case 4:
       filter.threshold(img);
       previousFrame = filter.modifiedImg;
    break;
    ////////////////// //Sepia Filter//////////////////////
    case 5:
       filter.sepia(img);
       previousFrame = filter.modifiedImg;
    break;
    ////////////////// //Invert Filter//////////////////////
    case 6:
       filter.invert(img);
       previousFrame = filter.modifiedImg;
    break;
    ////////////////////Posterize Filter////////////////////
    case 7:
       filter.posterize(img);
       previousFrame = filter.modifiedImg;
    break;
    case 8:
    ///////////////////////Warhol1 Filter//////////////////  
       filter.warhol1(img);
       previousFrame = filter.modifiedImg;  
    break;
    ////////////////Warhol2 Filter////////////////////
    case 9:
       filter.warhol2(img);
       previousFrame = filter.modifiedImg;
    break;
  }  
break;//break case 3 filter menu
//*********************Transform menu********************** 
 
 case 4://Transform menu
  menuHeight = buttonSize/3;//reset the menu height when the submenus are not displayed, so submenus don't trigger if not visible
   switch(submenuPressed){
     ///////////////////////// Tansform Menu ////////////////////////// 
     case 0:
        previousFrame =  previousFrame != null ? previousFrame : img;
        image(previousFrame,0,0,width,height);//allow to wipe the other submenu if it was open
        String[] transformButtons = {"Exit menu", "Mirror", "Rotate", "Flip"};
        mainMenu.createSubmenu(transformButtons, menuPressed);
        menuHeight=(transformButtons.length+1)*buttonSize/3;//+1 = the parent menu button Transform
     break;
   ///////////////////////// Exit Menu ////////////////////////// 
     case 1:
       previousFrame = previousFrame != null ? previousFrame : img;
       image(previousFrame,0,0,width,height);
     break;
   ///////////////////////// Mirror  //////////////////////////// 
     case 2:
       transform.mirror(img);
       previousFrame = transform.modifiedImg;
     break;
  ///////////////////////// Rotate ////////////////////////////
     case 3:
        transform.rotate(img);
        previousFrame = transform.modifiedImg;
     break;
  ///////////////////////// Flip ////////////////////////////
     case 4:
       transform.flip(img);
       previousFrame = transform.modifiedImg;
     break;
   }     

 break;// break case 4 transform menu;
 case 5://about button
      background(0,57,66);
      mainMenu.writeCredits();
      about = true;
      menuButtons = new ArrayList(Arrays.asList("Go Back"));
 break;
}//end switch menus and submenus
  
  if(menuButtons != null){//draws all the menu buttons
    mainMenu.createMainMenu(menuButtons);
  }

}//end draw

//Instead of using the boolean mousePressed in the draw function, 
//I used the function mouseReleased because I needed the draw function
//to draw continually the images even when the mouse is not pressed for example when the display window is resized
//I used mouseReleased instead of mousePressed because of a bug that makes the app to freeze when calling selectInput in mousePressed
void mouseReleased(){
  if(mouseY < menuHeight && mouseX < menuWidth){
   menuPressed = (int)(mouseX / buttonSize);//determines which menu you clicked horizontally
   submenuPressed = (int) (mouseY /(buttonSize/3));//determines which submenu you clicked vertically
  //sent to draw automatically
  if(menuPressed == 0){//if you pressed the first button = open or go back button
      if(about == false){//first button is the open button
        String loadPath = selectInput("Select an image to process");  // Opens file chooser
        if (loadPath != null) {
          // If a file was selected
          img=loadImage(loadPath);
          if(img!=null){
            if(img.width >= 6*buttonSize){
              frame.setSize(img.width, img.height);
            }
            else{
              frame.setSize(6*buttonSize, img.height*6*buttonSize/img.width);
            }
            loaded = true;
            previousFrame = null;//so that when a new image is loaded it draws the new image but not the previous frame for ex. if you came from the about section or just saved an image 
          }
        }   
      }
      else{//first button is go back button, you clicked the go back button, we leave the about mode and redraw the previous state
          if(about){
            about = false;
            redraw();//because noLoop when pressing the about button
          }      
      }
  }//end if menuPressed 0
  if(menuPressed == 1){//if you pressed the save button
    if(saved){
      saved = false;
    }
  }//end if menuPressed 1

}//end if mouseY

}







